/*
Package:  moab
Module:   moab
Version:  3.2.6
Modified: Jul 20, 2004

Copyright:

  Copyright (C) 1999-2004 Cluster Resources, Inc

  All Rights Reserved

Disclaimer:

 THIS SOFTWARE IS PROVIDED AS IS AND CLUSTER RESOURCES INC (CRI) DISCLAIMS ALL WARRANTIES RELATING TO THE SOFTWARE, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  NEITHER CRI, NOR ANYONE INVOLVED IN THE CREATION, PRODUCTION, OR DELIVERY OF THE SOFTWARE SHALL BE LIABLE FOR ANY INDIRECT, CONSEQUENTIAL, OR INCIDENTAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE EVEN IF CRI HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES OR CLAIMS.  THE PERSON OR ENTITY USING THE SOFTWARE BEARS ALL RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE.
*/

/* socket util object */

int MSUInitialize(msocket_t *,char *,int,long,long);
int MSUIPCInitialize(void);
int MSUListen(msocket_t *);
int MSUConnect(msocket_t *);
int MSUDisconnect(msocket_t *);
int MSUFree(msocket_t *);
int MSUAcceptClient(msocket_t *,msocket_t *,char *,int);
int MSUSendData(msocket_t *,long,mbool_t,mbool_t);
int MSUSendPacket(int,char *,long,long);
int MSURecvData(msocket_t *,long,mbool_t);
int MSURecvPacket(int,char **,long,char *,long);
int MSUSelectWrite(int,unsigned long);
int MSUSelectRead(int,unsigned long);
int MSUCreate(msocket_t **);
int MSUAdjustSBuffer(msocket_t *,int,mbool_t);



/* sec object */

int MSecGetChecksum(char *,int,char *,char *,enum MChecksumAlgoEnum,char *);
int MSecGetChecksum2(char *,int,char *,int,char *,char *,enum MChecksumAlgoEnum,char *);
int MSecTestChecksum(char *);
int MSecBufTo64BitEncoding(char *,int,char *);
int MSecBufToHexEncoding(char *,int,char *);


/* XML object */

int MXMLCreateE(mxml_t **,char *);
int MXMLDestroyE(mxml_t **);
int MXMLExtractE(mxml_t *,mxml_t *,mxml_t **);
int MXMLSetAttr(mxml_t *,char *,void *,enum MDataFormatEnum);
int MXMLAppendAttr(mxml_t *,char *,char *,char);
int MXMLSetVal(mxml_t *,void *,enum MDataFormatEnum);
int MXMLAddE(mxml_t *,mxml_t *);
int MXMLToString(mxml_t *,char *,int,char **,mbool_t);
int MXMLGetAttr(mxml_t *,char *,int *,char *,int);
int MXMLGetAttrF(mxml_t *,char *,int *,void *,enum MDataFormatEnum,int);
int MXMLGetChild(mxml_t *,char *,int *,mxml_t **);
int MXMLFromString(mxml_t **,char *,char **,char *);


/* sss interface object */

int MSSSLoadModule(mrmfunc_t *);
int MSSSDoCommand(mpsi_t *,char *,char **,mxml_t **);
int MSSSSetup(int);



int MSSSAddSet(mxml_t *,char *,char *,mxml_t **);
int MSSSAddWhere(mxml_t *,char *,char *);
int MSSSGetSet(mxml_t *,mxml_t **,int *,char *,int,char *,int);
int MSSSGetWhere(mxml_t *,mxml_t **,int *,char *,int,char *,int);
int MSSSSetObject(mxml_t *,char *,char *);
int MSSSGetObject(mxml_t *,char *);
int MSSSAddGet(mxml_t *,char *,mxml_t **);
int MSSSGetGet(mxml_t *,mxml_t **,int *,char *,int);
int MSSSSetStatus(mxml_t *,char *,enum MSFC,char *);
int MSSSCheckStatus(mxml_t *,enum MSFC *,char *);

/* END mcom-proto.h */

