/*
Package:  moab
Module:   moab
Version:  3.2.6
Modified: Jul 20, 2004

Copyright:

  Copyright (C) 1999-2004 Cluster Resources, Inc

  All Rights Reserved

Disclaimer:

 THIS SOFTWARE IS PROVIDED AS IS AND CLUSTER RESOURCES INC (CRI) DISCLAIMS ALL WARRANTIES RELATING TO THE SOFTWARE, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  NEITHER CRI, NOR ANYONE INVOLVED IN THE CREATION, PRODUCTION, OR DELIVERY OF THE SOFTWARE SHALL BE LIABLE FOR ANY INDIRECT, CONSEQUENTIAL, OR INCIDENTAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE EVEN IF CRI HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES OR CLAIMS.  THE PERSON OR ENTITY USING THE SOFTWARE BEARS ALL RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE.
*/

/* enumerations */

enum MSocketProtocolEnum {
  mspNONE = 0,
  mspSingleUseTCP,
  mspHalfSocket,
  mspHTTPClient,
  mspHTTP,
  mspSSSChallenge };

enum MWireProtocolEnum {
  mwpNONE = 0,
  mwpAVP,
  mwpXML,
  mwpHTML,
  mwpSSS2 };

enum MChecksumAlgoEnum {
  mcsaNONE = 0,
  mcsaDES,
  mcsaHMAC,
  mcsaHMAC64,
  mcsaMD5,
  mcsaRemote };

enum MPeerServiceEnum {
  mpstNONE = 0,
  mpstNM,    /* system monitor     */
  mpstQM,    /* queue manager      */
  mpstSC,    /* scheduler          */
  mpstMS,    /* meta scheduler     */
  mpstPM,    /* process manager    */
  mpstAM,    /* allocation manager */
  mpstEM,    /* event manager      */
  mpstSD,    /* service directory  */
  mpstWWW }; /* web                */

enum MSSSVEnum {
  msssV0_2 = 0,
  msssV2_0,
  msssV3_0 };


/* failure codes */

/* sync w/MFC[] */

enum MSFC {
  msfENone          = 0,    /* success */
  msfGWarning       = 100,  /* general warning */
  msfEGWireProtocol = 200,  /* general wireprotocol/network failure */
  msfEBind          = 218,  /* cannot bind socket */
  msfEGConnect      = 220,  /* general connection failure */
  msfCannotConnect  = 222,  /* cannot connect */
  msfCannotSend     = 224,  /* cannot send data */
  msfCannotRecv     = 226,  /* cannot receive data */
  msfConnRejected   = 230,  /* connection rejected */
  msfETimedOut      = 232,  /* connection timed out */
  msfEFraming       = 240,  /* general framing failure */
  msfEEOF           = 246,  /* unexpected end of file */
  msfEGMessage      = 300,  /* general message format error */
  msfEGSecurity     = 400,  /* general security failure */
  msfESecClientAuth = 442,  /* security - client auth failure */
  msfEGEvent        = 500,  /* general event failure */
  msfEGServer       = 700,  /* general server error */
  msfEGClient       = 800,  /* general client error */
  msfECInternal     = 820,  /* client internal error */
  msfECResUnavail   = 830,  /* client resource unavailable */
  msfECPolicy       = 840,  /* client policy failure */
  msfEGMisc         = 900,  /* general miscellaneous error */
  msfUnknownError   = 999 }; /* unknown failure */

/* const defines */

#define MMAX_SBUFFER        524288

#define MCONST_SSSXPATH     3

#define MMAX_SSSATTR        256
#define MMAX_SSSVERS        4
#define MMAX_SSSJACTION     64

/* default defines */

#define MDEF_CSALGO         mcsaDES
#define MMAX_SOCKETWAIT     5000000

#define MMAX_XMLATTR        64
#define MDEF_XMLICCOUNT     16

/* structures */

typedef struct mxml_s {
  char *Name;
  char *Val;

  int   ACount;
  int   ASize;

  int   CCount;
  int   CSize;

  char **AName;
  char **AVal;

  struct mxml_s **C;
  } mxml_t;

char *MSSSObjName[MMAX_SSSVERS][MMAX_SSSATTR];

#ifdef __M32COMPAT

#define mlog_t dlog_t

#endif /* __M32COMPAT */

/* END mcom.h */


