/*
Package:  moab
Module:   MXConfig.c
Version:  3.2.6
Modified: Jul 20, 2004

Copyright:

  Copyright (C) 1999-2004 Cluster Resources, Inc

  All Rights Reserved

Disclaimer:

 THIS SOFTWARE IS PROVIDED AS IS AND CLUSTER RESOURCES INC (CRI) DISCLAIMS ALL WARRANTIES RELATING TO THE SOFTWARE, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  NEITHER CRI, NOR ANYONE INVOLVED IN THE CREATION, PRODUCTION, OR DELIVERY OF THE SOFTWARE SHALL BE LIABLE FOR ANY INDIRECT, CONSEQUENTIAL, OR INCIDENTAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE SOFTWARE EVEN IF CRI HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES OR CLAIMS.  THE PERSON OR ENTITY USING THE SOFTWARE BEARS ALL RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE.
*/

  /* base scheduler functions */

  X->JobSetCreds          = MJobSetCreds;
  X->JobAllocateResources = MJobAllocMNL;
  X->JobGetStartPriority  = MJobGetStartPriority;      
  X->JobCheckPolicies     = MJobCheckPolicies;
  X->JobDistributeTasks   = MJobDistributeTasks;
  X->JobFind              = MJobFind;      
  X->JobGetTasks          = MJobSelectMNL;          
  X->JobGetFeasibleTasks  = MReqGetFNL;          
  X->JobStart             = MJobStart;        
  X->JobBuildCL           = MJobBuildCL;
  X->JobBuildACL          = NULL;
  X->JobSetQOS            = MJobSetQOS;
  X->JobNameAdjust        = MJobGetName;
  X->JobValidate          = MJobValidate;
  X->JobDetermineCreds    = MJobDetermineCreds;

  X->BackFill             = MQueueBackFill;                        
  X->DoWikiCommand        = MWikiDoCommand;

  X->ResFind              = MResFind;
  X->JobGetRange          = MJobGetRange;         
  X->ReservationDestroy   = MResDestroy;     
  X->ReservationCreate    = MResCreate;
  X->ReservationJCreate   = MResJCreate;

  X->AcctFind             = MAcctFind;

  X->RMCancelJob          = MRMJobCancel;      
  X->RMJobStart           = MRMJobStart;       

  X->PBSInitialize        = NULL;

  X->JobGetSNRange        = MJobGetSNRange;
  X->JobSetAttr           = MJobSetAttr;
  X->ResSetAttr           = MResSetAttr;

  X->QOSGetAccess         = MQOSGetAccess;

  X->QueuePrioritizeJobs  = MQueuePrioritizeJobs;     
  X->QueueScheduleJobs    = MQueueScheduleIJobs;      

  X->LL2ShowError         = LL2ShowError;

  X->SimJobSubmit         = MSimJobSubmit;
  X->SRCreate             = MSRSetRes;
  X->WikiLoadJob          = MWikiJobLoad;

  X->QBankDoTransaction   = MAMQBDoCommand;

  /* extension functions */

  X->XUIHandler                 = XUIHandler;

  X->XJobProcessWikiAttr        = XJobProcessWikiAttr;

  X->XJobDestroy                = XJobDestroy;

  X->XPBSInitialize             = XPBSInitialize;
  X->XPBSNMGetData              = XPBSNMGetData;
  X->XRMInitialize              = XRMInitialize;
  X->XRMResetState              = XRMResetState;
  X->XRMVerifyData              = XRMVerifyData;
  X->XRMJobResume               = XRMJobResume;
  X->XRMJobSuspend              = XRMJobSuspend;
  X->XUpdateState               = XUpdateState;
  X->XMetaStoreCompletedJobInfo = NULL;
  X->XAllocMachinePrio          = XAllocMachinePrio;
  X->XAllocLoadBased            = XAllocLoadBased;

  X->XGetClientInfo             = NULL;

  X->XJobAllocateResources      = NULL;
 
  /* base scheduler data */

  X->Acct         = MAcct;
  X->AttrList     = &MAList;
  X->Sched        = &MSched;
  X->Stat         = &MStat;
  X->CREndTime    = &CREndTime;
  X->CurrentHostName = CurrentHostName;
  X->dlog         = &mlog;
  X->Group        = MGroup;
  X->Job          = MJob;
  X->MNode        = MNode;
  X->MRange       = MRange;  
  X->MPar         = MPar;
  X->PresentTime  = &MSched.Time; 
  X->MQOS         = MQOS;
  X->Res          = MRes;
  X->RM           = MRM;
  X->AM           = MAM;
  X->User         = MUser;

  /* extension data */

  X->xd           = NULL;

/* END MXConfig.c */

